//NumKonvertieren_201d.js
// 22.04.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Wandelt Nummerierungen in normalen Text um

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// ein paar Variablen
var allStories;
var curDoc = app.documents[0];
var curItem;
var curType;
var curStory;

// die Auswahl testen
var selItems = app.selection;
var nItems = selItems.length;

// wenn keine Auswahl, einen Dialog zum Besttigen zeigen
if (nItems == 0) {
	userDec = confirm("Im ganzen Dokument die Nummerierungen umwandeln?");
	if (userDec == true) {
		allStories = curDoc.stories.everyItem();
		allStories.convertBulletsAndNumberingToText();
	}
	else {
		exit();
	}
}
// sonst eine Schleife durch die Auswahl
else {
	for (var i=0; i<nItems; i++) {
		curItem = selItems[i];
		testItems(curItem);
	}
}

alert ("Fertig.", "NumKonvertieren");

// der Handler, welche die Objekte prft und allfllige 
// Mummerierungen umwandelt
function testItems(curItem) {
	curType = curItem.constructor.name;
	if (curType == "TextFrame") {
		curStory = curItem.parentStory;
		curStory.convertBulletsAndNumberingToText();
	}
	else if (curType == "InsertionPoint" || curType == "Character" 
		|| curType == "Text" || curType == "Word" || curType == "Line" 
		|| curType == "Paragraph" || curType == "TextStyleRange" 
		|| curType == "TextColumn") {
		curItem.convertBulletsAndNumberingToText();
	}
	else if (curType == "Group") {
		testGroups(curItem);
	}
}

// der Hndler, welche Gruppen behandelt, ohne sie aufzulsen
function testGroups(curGroup) {
	var allFrames = curGroup.allPageItems;
	for (var i=0; i< allFrames.length; i++) {
		var curFrame = allFrames[i];
		var curType = curFrame.constructor.name;
		if (curType == "Group") {
			testGroups(curFrame);
		}
		else if (curType == "TextFrame") {
			curStory = curFrame.parentStory;
			curStory.convertBulletsAndNumberingToText();
		}
	}
}